module RouteNGNClient
  class Code < RemoteModel

    set_resource_attributes({
                              :path_base => 'metallic/codes',
                              :collection_name => 'codes',
                              :per_page => 200,
                              :request_options => {
                              }
                            })

    class << self

      def find_by_exploded_dialcode(dialcode, options = {}, &callback)
        subsets = Utils.string_subsets dialcode
        find_by_dialcodes subsets, options, &callback
      end

      def find_by_dialcodes(dialcodes, options = {}, &callback)
        options = {:page => 1, :per_page => (dialcodes.length + 1)}.merge(self.resource_attributes[:request_options]).merge(options)

        models = all({:code => {:dialcode => {'$in' => dialcodes}}}, options)

        callback.call(models) if callback

        models
      end

    end

  end
end