module RouteNGNClient
  class Route < Model

    belongs_to :route_table, :outbound_end_point_group
    has_one :outbound_rate

    def contacts
      @contacts ||= self.build_contacts
    end

    def build_contacts(end_points = nil)
      if oepg = self.outbound_end_point_group
        end_points ||= oepg.prioritized_end_points
        @contacts = end_points.collect do |end_point|
          Contact.new(:end_point => end_point, :route => self)
        end
      end
    end

    def build_aors(sip_request, inbound_end_point_group, options = {})
      self.contacts.collect { |c| c.build_aor(sip_request, inbound_end_point_group, options) }
    end

    def inbound_rate
      @attributes.inbound_rate
    end

    def blocked?
      @attributes.has_key?('blocked') && @attributes.blocked == 'true' ? true : false
    end

    comma do
      outbound_rate :price => 'outbound_rate_price'
      outbound_rate :type => 'outbound_rate_type'
      outbound_rate :dialcode => 'outbound_rate_dialcode'
      outbound_rate :lata => 'outbound_rate_lata'
      outbound_rate :ocn => 'outbound_rate_ocn'
      outbound_end_point_group :name => 'outbound_end_point_group_name'
    end

  end
end